unit par;
                                                                                                                                            
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, Buttons, MMTimer ,utils, Placemnt;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Outputs1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    StatusBar1: TStatusBar;
    Test1: TMenuItem;
    Emulateoutputs1: TMenuItem;
	SecTimer: TTimer;
    SaveDlg: TSaveDialog;
    msTimer: TMMTimer;
    Save1: TMenuItem;
    Cleartext1: TMenuItem;
    Setport1: TMenuItem;
    FormStorage1: TFormStorage;
    //procedure InputBtnClick(Sender: TObject);
    //procedure FormCreate(Sender: TObject);
    //procedure CheckBox1Click(Sender: TObject);
    //procedure Timer1Timer(Sender: TObject);
    //procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure About1Click(Sender: TObject);
	procedure Exit1Click(Sender: TObject);
	procedure ResetRecord;
	procedure Test1Click(Sender: TObject);
	procedure Emulateoutputs1Click(Sender: TObject);
	procedure SecTimerTimer(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure msTimerTimer(Sender: TObject);
	procedure Save1Click(Sender: TObject);
//        procedure CheckInputs(var lD0: boolean; var lEPrimeNibble: integer {nibble=4bits of data});
	procedure SaveCore;
	procedure AutoSave;
	procedure FormStorage1RestorePlacement(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Cleartext1Click(Sender: TObject);
    procedure Setport1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses test, emulate;

{$R *.DFM}
function Inp32(wAddr:word):byte; stdcall; external 'inpout32.dll';
const
 kVers = 'ezlog 1/2010 www.mricro.com'; 
 kCR = chr (13);//PC EOLN
 kTab = chr(9);
 PathDelim = '\';
 kMaxEvents = 32000;
 kTimeout =  22000;
 kInputs = 15;

var
 gDra: array [0..kInputs,1..kMaxEvents] of integer;
 gFilename: string;
 gRecStartTime,gMostRecentEvent: DWord;
 gDnum: array [0..kInputs] of integer;
 gD0On : boolean;
 gRecordStartDateTime, gScannerStartDateTime: TDateTime;

 //gInc,
 gInputNibble: integer;
 //gDOn: array [0..kInputs] of boolean;
 gDStr: array [0..kInputs] of  string[10];

(*procedure CheckInputs(var lD0,lD1,lD2,lD3,lD4: boolean);
var lInByte : byte;
begin
 lInByte := (Inp32($379)and $F8);
 lD0 := not ((lInByte and 128) > 0);
 lD1 :=  ((lInByte and 64) > 0);
 lD2 :=  ((lInByte and 32) > 0);
 lD3 :=  ((lInByte and 16) > 0);
 lD4 :=  ((lInByte and 8) > 0);
end;*)
(*procedure TMainForm.CheckInputs(var lD0: boolean; var lEPrimeNibble: integer {nibble=4bits of data});
var lInByte : byte;
lShift : TKeyboardState;
result: boolean;
begin
  if true then begin
    GetKeyboardState(lShift) ;
    result := ((lShift[5] And 128) <> 0) ;
    if result then
          mainform.caption := inttostr(lInByte)+'  '+inttostr(random(888));//lInByte := 128
  end;
 lD0 := not ((lInByte and 128) > 0);
 lEPrimeNibble := 0;
 if ((lInByte and 8) > 0) then lEPrimeNibble := lEPrimeNibble + 1;
 if ((lInByte and 16) > 0) then lEPrimeNibble := lEPrimeNibble + 2;
 if ((lInByte and 32) > 0) then lEPrimeNibble := lEPrimeNibble + 4;
 if ((lInByte and 64) > 0) then lEPrimeNibble := lEPrimeNibble + 8;
end;*)



procedure TMainForm.About1Click(Sender: TObject);
begin
	Showmessage(kVers+kCR+
    ' Connect TTL inputs for scanner, bit0, bit1, bit2 and bit3 to pins 11, 15, 13, 12, 10 respectively. '+'Ground should also be connected between parallel port (pins 18-25) and TTL inputs. EPrime can send outputs using inlines calls such as ''WritePort 888, c.GetAttrib(""PortOut"")''  to send value listed in PortOut list. ');
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
     MainForm.Close;
end;

procedure TMainForm.ResetRecord;
var lInc: integer;
begin
	SecTimer.Enabled := false;
	//Memo1.Lines.Clear;
	gRecordStartDateTime := Now;
	//gFilename := TestForm.SaveDirBtn.Caption+PathDelim+ (FormatDateTime('dmmmyy_hhnn', (now)))+'.txt';
	gFilename := TestForm.SaveDirBtn.Caption+PathDelim+ (FormatDateTime('yyyymmdd_hhnnss', (now)))+'.txt';
	//Memo1.Lines.Add(gFilename);
	Memo1.Lines.Add('Recording started at '+DateTimeToStr(gRecordStartDateTime)+'   '+ kVers);
	gDStr[0] := TestForm.Scanner.Text;
	gDStr[1] := TestForm.Edit1.Text;
	gDStr[2] := TestForm.Edit2.Text;
	gDStr[3] := TestForm.Edit3.Text;
	gDStr[4] := TestForm.Edit4.Text;
	gDStr[5] := TestForm.Edit5.Text;
	gDStr[6] := TestForm.Edit6.Text;
	gDStr[7] := TestForm.Edit7.Text;
	gDStr[8] := TestForm.Edit8.Text;
	gDStr[9] := TestForm.Edit9.Text;
	gDStr[10] := TestForm.Edit10.Text;
	gDStr[11] := TestForm.Edit11.Text;
	gDStr[12] := TestForm.Edit12.Text;
	gDStr[13] := TestForm.Edit13.Text;
	gDStr[14] := TestForm.Edit14.Text;
	gDStr[15] := TestForm.Edit15.Text;
	//gInc := 0;
	for lInc := 0 to kInputs do
		gDnum[lInc] := 0;
	CheckInputs(gD0On,gInputNibble);
	//gD0On := false;
	StatusBar1.Panels[0].text := 'Waiting for 1st pulse';
	gRecStartTime := GetTickCount;
	//CheckInputs(gD0on,lINc);
	msTimer.Enabled := true;
end;

procedure TMainForm.Test1Click(Sender: TObject);
begin
	 TestForm.Showmodal;
end;

procedure TMainForm.Emulateoutputs1Click(Sender: TObject);
begin
	 EmulateForm.Show;
end;

procedure TMainForm.SecTimerTimer(Sender: TObject);
var lTimeSinceLastRF: DWord;
begin
	 StatusBar1.Panels[0].text := HourMinSecStr(GetTickCount-gRecStartTime);
		lTimeSinceLastRF := (GetTickCount - gMostRecentEvent);
		if lTimeSinceLastRF > kTimeOut then begin
		   SecTimer.Enabled := false;
		   AutoSave;
		end;
(*	 if (gDnum[0] >= 1) then begin
		lTimeSinceLastRF := (GetTickCount - gRecStartTime) -gDra[0,gDnum[0]];
		if lTimeSinceLastRF > kTimeOut then begin
		   SecTimer.Enabled := false;
		   AutoSave;
		end;
	 end else begin //no RF pulses detected - save if experiment is over
		lTimeSinceLastRF := (GetTickCount - gMostRecentEvent);
		if lTimeSinceLastRF > kTimeOut then begin
		   SecTimer.Enabled := false;
		   AutoSave;
		end;
	 end;*)
end;
procedure TMainForm.SaveCore;
var
 lMean,lMean0: double;
 lError,lPos,lBit: integer;
 lEmpty: boolean;
 lTextFile:TextFile;
begin
        lEmpty := true;
	for lBit := 1 to kInputs do
		if gDnum[lBit] > 0 then
                   lEmpty := false;
        if lEmpty then begin
           if gDnum[0] > 0 then
              Memo1.Lines.Add('No data saved: only scanner pulses, no EPrime signals (DTI sequence?)')
           else
               Memo1.Lines.Add('No data saved: no data recorded');
	   ResetRecord;
           exit;
        end;
	lMean0 := 0;
	{$I-}
	assignfile(lTextFile,SaveDlg.FileName);
	rewrite(lTextFile);
	  {$I+}
	lerror := ioresult;
	if lerror <> 0 then begin
	 if lError = 32{fileexists(SaveDlg.FileName)} then
		 ShowMessage('Unable to save file. The file you want to overwrite is being used by another program. Make sure you have write permission and free disk space. I/O error: '+inttostr(lerror))
	 else
		 ShowMessage('Unable to save file. Make sure you have write permission and free disk space. I/O error: '+inttostr(lerror));
	 //closefile(lTextFile);
	 exit;
	end;
	Memo1.Lines.Add('Saving data as '+SaveDlg.FileName);
	writeln(lTextFile,'Recording started at '+DateTimeToStr(gRecordStartDateTime));
	writeln(lTextFile,'Scanner pulses started at '+DateTimeToStr(gScannerStartDateTime));
	for lBit := 0 to kInputs do begin
		if gDnum[lBit] > 0 then begin
		   if gDnum[lBit] > 1 then
			  lMean := gDra[lBit,gDNum[lBit]]/(gDNum[lBit]-1)
		   else
			   lMean := 0;
		   if lBit = 0 then lMean0 := lMean;
		   writeln(lTextFile,gDStr[lBit]+',number,'+inttostr(gDNum[lBit])+',mean_ms,'+floattostr(lMean));
		   if gDNum[lBit] > 1 then
			  for lPos := 1 to (gDNum[lBit]-1) do
				  write(lTextFile,inttostr(gDra[lBit,lPos])+','  );
		   writeln(lTextFile,inttostr(gDra[lBit,gDNum[lBit]]));
		end;
	end; //for each input line
	//show intervals in terms of TRs
	(*if lMean0 <> 0 then begin
	  writeln(lTextFile,'Following values as scanner TR rather than milliseconds');
	  for lBit := 1 to kInputs do begin
		if gDnum[lBit] > 0 then begin
		   if gDnum[lBit] > 1 then
			  lMean := gDra[lBit,gDNum[lBit]]/(gDNum[lBit]-1)
		   else
			   lMean := 0;
		   lMean := lMean / lMean0;
		   writeln(lTextFile,gDStr[lBit]+',number,'+inttostr(gDNum[lBit])+',mean_scans,'+floattostr(lMean));
		   if gDNum[lBit] > 1 then
			  for lPos := 1 to (gDNum[lBit]-1) do
				  write(lTextFile,floattostr(gDra[lBit,lPos] / lMean0)+','  );
		   writeln(lTextFile,floattostr(gDra[lBit,gDNum[lBit]]/lMean0));
		end;
	  end; //for each input line
	end; //mean0<>0 TR recorded*)
	//next FSL style
	for lBit := 1 to kInputs do begin//start from 1, do not save volume onsets
		if gDnum[lBit] > 1 then begin
		   writeln(lTextFile,'FSL onsets for '+gDStr[lBit]+'  Note: adjust times if you specify DELETE VOLUMES > 0 or SLICE TIMING CORRECTION');
		   for lPos := 1 to (gDNum[lBit]) do  //floattostrf(lDicomData.TR,ffFixed,8,3)
				  writeln(lTextFile,floattostrf(gDra[lBit,lPos]/1000,ffFixed,8,3)+kTab+'1'+kTab+'1' );
		end;
	end; //for each input line
	//write(lTextFile,lDynStr);
	closefile(lTextFile);
	MainForm.StatusBar1.Panels[1].text := 'Data saved as '+SaveDlg.Filename;
	ResetRecord;
end;

function DataCollected: boolean;
var
	lBit: integer;
begin
	 result := false;
	 for lBit := 0 to kInputs do
		 if gDnum[lBit] > 0 then result := true;
end;

procedure TMainForm.AutoSave;
begin
	if not DataCollected then
		exit;
	SaveDlg.FileName := gFilename;
	SaveCore;
end;

procedure TMainForm.Save1Click(Sender: TObject);
begin
	 if not DataCollected then begin
		 showmessage('No data available for saving to disk. Please record a session first.');
		 exit;
	 end;
	if not SaveDlg.Execute then exit;
	SaveCore;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var lBit: integer;
begin
     //SetDefaultAppPrefs(gAppPrefs);
     //AppIniFile(true, AppIniFilename, gAppPrefs);
	 for lBit := 0 to kInputs do
		 gDnum[lBit] := 0;
end;


procedure TMainForm.msTimerTimer(Sender: TObject);
var lD0on,lInputs : boolean;
  lInputNibble,lBit,lEvent: integer;
  lEventTime: DWord;
begin
  CheckInputs(lD0on,lInputNibble);

  if lD0on <> gD0On then begin
	 gD0On := lD0On;
	 if lD0on then begin
		//Memo1.Lines.Add('mstTX ->'+inttostr(gDnum[0]) );
		gMostRecentEvent := GetTickCount;
		inc(gDnum[0]);
		if (gDnum[0] = 1) then begin
		  gRecStartTime := GetTickCount;
		  lEventTime := GetTickCount - gRecStartTime;
		  gDra[0,gDnum[0]] := lEventTime;
		  for lBit := 1 to kInputs do begin
			  if gDnum[lBit] > 0 then begin
				 for lEvent := 1 to gDnum[lBit] do
					 gDra[lBit,lEvent] := gDra[lBit,lEvent]-lEventTime;
			  end; //if inputs collected prior to first TTL pulse
		  end; //for each input line
		  SecTimer.Enabled := true;
		  gScannerStartDateTime := Now;
		  Memo1.Lines.Add('Scanner pulses started at '+DateTimeToStr(gScannerStartDateTime));
		  //gFilename := TestForm.SaveDirBtn.Caption+PathDelim+ (FormatDateTime('dmmmyy_hhnnss', (now)))+'.txt';
		  gFilename := TestForm.SaveDirBtn.Caption+PathDelim+ (FormatDateTime('yyyymmdd_hhnnss', (now)))+'.txt';
		  //Memo1.Lines.Add(gFilename);
		  SecTimerTimer(nil);
		end;
		//gMostRecentEvent := GetTickCount;
		lEventTime := GetTickCount - gRecStartTime;
		gDra[0,gDnum[0]] := lEventTime;
		memo1.lines.Add(gDStr[0]+' '+inttostr(gDnum[0])+'@'+inttostr(lEventTime));
	 end;
  end;
  if lInputNibble <> gInputNibble then begin
	 gMostRecentEvent := GetTickCount;
	 if (gDnum[0] < 1) then begin //no RF pulses
		lInputs := false;
		for lBit := 1 to kInputs do
			  if gDnum[lBit] > 0 then
				lInputs := true;
		if not lInputs then begin
			ResetRecord;
			SecTimer.Enabled := true;
		end;
	 end; //noRF pulses
	 gInputNibble := lInputNibble;
	 if lInputNibble <> 0 then begin
		inc(gDnum[lInputNibble]);
		lEventTIme := GetTickCount - gRecStartTime;
		gDra[lInputNibble,gDnum[lInputNibble]] := lEventTime;
		memo1.lines.Add(gDStr[lInputNibble]+' '+inttostr(gDnum[lInputNibble])+'@'+inttostr(lEventTime));
	 end;
  end;
end;


procedure TMainForm.FormStorage1RestorePlacement(Sender: TObject);
begin
        if SetPort1.Tag < 1 then
           SetPort1.Tag := 888;
        gPort := SetPort1.Tag;
	ResetRecord;

end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if SecTimer.Enabled then begin
		beep;
		CanClose := false;
		exit;
	end;
	beep;
	case MessageDlg('Do you really want to quit the ezLog data logger? This software is useful for fMRI studies.', mtConfirmation,
	 [mbYes, mbNo], 0) of	{ produce the message dialog box }
	 id_No: CanClose := false;
  end;
end;

procedure TMainForm.Cleartext1Click(Sender: TObject);
begin
	case MessageDlg('Do you really want to erase the text display?', mtConfirmation,
	 [mbYes, mbNo], 0) of	{ produce the message dialog box }
	 id_No: exit;
  end;
	if not DataCollected then begin
		SaveDlg.FileName := gFilename;
		SaveCore;
	end;

	Memo1.Lines.Clear;
end;

procedure TMainForm.Setport1Click(Sender: TObject);
var
  lS: string;
  lI: integer;
begin
  lS := inttostr(gPort);
  if not InputQuery('LPT port address ', 'Address (check device manager, often 888 [378hex])' , lS) then
   exit;
 lI := strtoint(lS);
 if lI < 2 then
  exit;
 gPort := lI;
 SetPort1.Tag := gPort;
 PortSetup;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //AppIniFile(false, AppIniFilename, gAppPrefs);
end;

end.
