unit utils;

interface

procedure CheckInputs(var lD0: boolean; var lEPrimeNibble: integer {nibble=4bits of data});
procedure Out32x(lPort: word; lVal: byte);
procedure PortSetup;
//function Inp32x(lPort:word):byte;
var
   gPort: integer = 888;
   gSwap: boolean = false;
      kKBEmulate : boolean =  false;
(*type
  TAppPrefs = record
         Port: integer;
  end;
var
gAppPrefs : TAppPrefs;
procedure SetDefaultAppPrefs (var lPrefs: TAppPrefs);
function AppIniFile(lRead: boolean; lFilename: string; var lPrefs: TAppPrefs): boolean;
function AppIniFilename: string;*)

implementation

//uses inifiles, sysutils;
uses
  Windows, //Messages, SysUtils,
  Classes, //Graphics, Controls,
  Forms//, Dialogs//,
  //StdCtrls, ExtCtrls, Menus, ComCtrls, Buttons, MMTimer , Placemnt
  ;

function Out32(wAddr:word;bOut:byte):byte; stdcall; external 'inpout32.dll';
function Inp32(wAddr:word):byte; stdcall; external 'inpout32.dll';


procedure Out32x(lPort: word; lVal: byte);
begin
     Out32(gPort,lVal);
end;

procedure PortSetup;
   var lD0: boolean; var lEPrimeNibble: integer;
begin
     Out32(gPort+2,244);
     CheckInputs(lD0, lEPrimeNibble);
     gSwap :=  lD0;
end;

function Inp32x(lPort:word):byte;
begin
     result :=  Inp32(gPort+1);//1/2010 : LPT input address is +2 of base address
end;

(* AltKeyDown := HighOrderBitSet(Word(GetKeyState(VK_MENU)));
   CtrlKeyDown := HighOrderBitSet(Word(GetKeyState(VK_CONTROL)));
   ShiftKeyDown := HighOrderBitSet(Word(GetKeyState(VK_SHIFT)));
   LeftShiftKeyDown := HighOrderBitSet(Word(GetKeyState(VK_LSHIFT)));
   // other VK's:
  // VK_LSHIFT	    VK_RSHIFT
  // VK_LCONTROL    VK_RCONTROL
  // VK_LMENU       VK_RMENU*)

procedure CheckInputs(var lD0: boolean; var lEPrimeNibble: integer {nibble=4bits of data});
var lInByte : byte;
begin
     if kKBEmulate then begin
        lInByte := 128;
        //HighOrderBitSet(Word(GetKeyState(VK_LSHIFT)))
	if (ssCtrl in KeyDataToShiftState(vk_Shift)) then
           lInByte := lInByte+8;

	if (ssShift in KeyDataToShiftState(vk_Shift)) then
           lInByte:= lInByte - 128;
     end else //not emulate
         lInByte := (Inp32($379)and $F8);
 if gSwap then
     lD0 := ((lInByte and 128) > 0)
 else
     lD0 := not ((lInByte and 128) > 0);

 lEPrimeNibble := 0;
 if ((lInByte and 8) > 0) then lEPrimeNibble := lEPrimeNibble + 1;
 if ((lInByte and 16) > 0) then lEPrimeNibble := lEPrimeNibble + 2;
 if ((lInByte and 32) > 0) then lEPrimeNibble := lEPrimeNibble + 4;
 if ((lInByte and 64) > 0) then lEPrimeNibble := lEPrimeNibble + 8;
end;

(*

function AppDir: string; //e.g. c:\folder\ for c:\folder\myapp.exe, but /folder/myapp.app/ for /folder/myapp.app/app
begin
 result := extractfilepath(paramstr(0));
end;

function AppIniFilename: string;
//var lPath,lName,lExt: string;
begin
  //FilenameParts (Paramstr(0), lPath,lName,lExt );
  result := AppDir+ 'ezlog.ini'
end;

procedure SetDefaultAppPrefs (var lPrefs: TAppPrefs);
var
  i: integer;
begin
  with lPrefs do begin
    Port := 888;//$FF00;
  end;
end;

procedure IniInt(lRead: boolean; lIniFile: TIniFile; lIdent: string;  var lValue: integer);
//read or write an integer value to the initialization file
var
	lStr: string;
begin
        if not lRead then begin
           lIniFile.WriteString('INT',lIdent,IntToStr(lValue));
           exit;
        end;
	lStr := lIniFile.ReadString('INT',lIdent, '');
	if length(lStr) > 0 then
		lValue := StrToInt(lStr);
end; //IniInt

function AppIniFile(lRead: boolean; lFilename: string; var lPrefs: TAppPrefs): boolean;
var
  lIniFile: TIniFile;
  lI: integer;
begin
  result := false;
  if lRead then
     SetDefaultAppPrefs(lPrefs);
  if (lRead) and (not Fileexists(lFilename)) then
        exit;
  lIniFile := TIniFile.Create(lFilename);
  IniInt(lRead,lIniFile, 'Port',lPrefs.Port);
  lIniFile.Free;
end;*)

end.
 