unit test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Placemnt, Buttons,ShellAPI,ShlObj,DiskSpaceKludge,utils;

type
	TInteger8 = Comp;  // 8-byte integer, since disk sizes may be > 2 GB
  TTestForm = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    OutputLabel: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    PulseCheck: TCheckBox;
    in8check: TCheckBox;
    in4check: TCheckBox;
    in2check: TCheckBox;
    Timer1: TTimer;
    OKBtn: TButton;
    Scanner: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    in1check: TCheckBox;
    Bevel2: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    FormStorage1: TFormStorage;
    Bevel3: TBevel;
    Label2: TLabel;
    SaveDirBtn: TSpeedButton;
    Label21: TLabel;
    EmulateCheck: TCheckBox;
    procedure Timer1Timer(Sender: TObject);
    procedure ReadInputs;
    procedure CheckBox1Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DoneBtn(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SaveDirBtnClick(Sender: TObject);
    procedure FormStorage1RestorePlacement(Sender: TObject);
    procedure EmulateCheckClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestForm: TTestForm;

   //kMouseEmulate : boolean = false;
implementation

uses par;

{$R *.DFM}
//function Out32(wAddr:word;bOut:byte):byte; stdcall; external 'inpout32.dll';
//function Inp32(wAddr:word):byte; stdcall; external 'inpout32.dll';

{Bit Pin Name
3   15   Error
4   13   Select In
5   12   Paper Empty
6   10   Acknowledge
7   11   Busy

0040:0008 has the address of LPT1, usually 378h
0040:000A has the address of LPT2
0040:000A has the address of LPT3, and
0040:000A has the address of LPT4}

(*function FirstLPT: integer;
	var
	lLPT: integer;
	lInc, lVal: word;
	begin
		{from 400-407 com ports avail: IntMsg('x', (mem[0000:($401)] shl 8)+mem[0000:($400)]) }
    lLPT := 0;
		for lInc := 3 downto 0 do begin
                       lVal:=mem[$0040:$08]+mem[$0040:$09]*256;
//			lVal := (mem[0000:($409+lInc)] shl 8)+mem[0000:($408+lInc)];
      if lVal <> 0 then
         lLPT := lVal;
		end;
    {IntMsg('1st LPT',lLPT); {}
    FirstLPT := lLPT;
end;(**)



procedure TTestForm.ReadInputs;
var
   lD0: boolean;
   lInByte : integer;
begin
     CheckInputs(lD0,lInByte);
 //lInByte := (Inp32x($379)and $F8);
 PulseCheck.checked := lD0;
 in1check.checked :=  ((lInByte and 1) > 0);
 in2check.checked :=  ((lInByte and 2) > 0);
 in4check.checked :=  ((lInByte and 4) > 0);
 in8check.checked :=  ((lInByte and 8) > 0);
//label2.caption:='When last read, the port was showing '+ inttostr((Inp32($379)and $F8));
end;

procedure TTestForm.Timer1Timer(Sender: TObject);
begin
  ReadInputs;
end;

procedure TTestForm.CheckBox1Click(Sender: TObject);
var bWriteMe {, bErr{}:byte;
begin
     bWriteMe := 0;
     if CheckBox1.Checked then bWriteMe := bWriteMe + 1;
     if CheckBox2.Checked then bWriteMe := bWriteMe + 2;
     if CheckBox3.Checked then bWriteMe := bWriteMe + 4;
     if CheckBox4.Checked then bWriteMe := bWriteMe + 8;
     if CheckBox5.Checked then bWriteMe := bWriteMe + 16;
     if CheckBox6.Checked then bWriteMe := bWriteMe + 32;
     if CheckBox7.Checked then bWriteMe := bWriteMe + 64;
     if CheckBox8.Checked then bWriteMe := bWriteMe + 128;
OutputLabel.caption:=inttostr(bWriteMe);
//bErr:=(Out32($378,bWriteMe));
Out32x($378,bWriteMe);
end;

procedure TTestForm.FormHide(Sender: TObject);
begin
 Timer1.enabled := false;
end;

procedure TTestForm.FormShow(Sender: TObject);
begin
 Timer1.enabled := true;
 Caption := 'INput/Output Port '+inttostr(gPort);
end;

procedure TTestForm.DoneBtn(Sender: TObject);
begin
     TestForm.Close;
end;

function ExtractFileDirWOPathDelim(lStr: string): string;
var
	lInc: Integer;
begin
	result := lStr;
	if length(lStr) < 2 then exit;
	if lStr[length(lStr)] <> '\' then
		exit;
	result :='';
	for lInc := 1 to (length(lStr)-1) do
		result := result + lStr[lInc];
end;

function DirExists (var lDir: String): boolean;
var lSearchRec: TSearchRec;
begin
  lDir := ExtractFileDirWOPathDelim(lDir);
  FindFirst(lDir, faAnyFile, lSearchRec);
	if (faDirectory and lSearchRec.attr) = faDirectory then
	   DirExists := true
	else
		DirExists := false;
  FindClose(lSearchRec);{}
end;

function BrowseDialog(const Title: string; const Flag: integer): string;
var
  lpItemID : PItemIDList;
  BrowseInfo : TBrowseInfo;
  DisplayName : array[0..MAX_PATH] of char;
  TempPath : array[0..MAX_PATH] of char;
begin
  Result:='';
  FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
  with BrowseInfo do begin
	hwndOwner := Application.Handle;
	pszDisplayName := @DisplayName;
	lpszTitle := PChar(Title);
	ulFlags := Flag;
  end;
  lpItemID := SHBrowseForFolder(BrowseInfo);
  if lpItemId <> nil then begin
	SHGetPathFromIDList(lpItemID, TempPath);
	Result := TempPath;
	GlobalFreePtr(lpItemID);
  end;
end;

function DiskFreeEx (DriveStr: String): Integer;
var
  lOutDisk: Integer;
  lDiskDir : string;
  lSize8: Tinteger8;
begin
     lOutDisk := ord(upcase(DriveStr[1]))+1-ord('A');
	 if (lOutDisk >= ord('A')) and (lOutDisk <= ord('Z')) then begin
        DiskFreeEx := DiskFree(lOutDisk);
	 end else begin
         lDiskDir :=(ExtractFileDrive(DriveStr))+'\';
         lSize8 := DiskFreeStr (lDiskDir);
         if lSize8 > MaxINt then DiskFreeEx := MaxInt
         else DiskFreeEx := round(lSize8);
	 end;
end;

procedure SetSaveDir (var lPathname: string);
begin
  if DirExists(lPathname) then
	TestForm.SaveDirBtn.caption := lPathname;
  //if gSearchDir[length(gSearchDir)] <> '\' then gSearchDir := gSearchDir + '\';
  if (DiskFreeEx(lPathname)) < 32000 then
	  showmessage('Warning: no free space in '+lPathname+'  [Check if you have write permission]');
end;

procedure TTestForm.SaveDirBtnClick(Sender: TObject);
var gSearchDir,sTitle: string;
	iFlag : integer;
begin
  sTitle:='Choose a folder for saving files';
  iFlag :=  BIF_RETURNONLYFSDIRS;
	//iFlag :=  BIF_BROWSEINCLUDEFILES;
	//iFlag :=  BIF_BROWSEFORCOMPUTER;
	//iFlag :=  BIF_BROWSEFORPRINTER;
  //memo1.lines.Clear;
  gSearchDir := BrowseDialog(sTitle, iFlag);
  if gSearchDir = '' then exit;
  if DirExists(gSearchDir) then
	SetSaveDir( gSearchDir);
  //if gSearchDir[length(gSearchDir)] <> '\' then gSearchDir := gSearchDir + '\';
  //showmessage(inttostr(DiskFreeEx(gSearchDir)));
  {if DirExists(gSearchDir) then
	SaveDirBtn.caption := gSearchDir;{}
end;

procedure TTestForm.FormCreate(Sender: TObject);
var
	lStr: string;
begin
	lStr := extractfiledir(paramstr(0));
	SetSaveDir( lStr);
        PortSetup;
end;


procedure TTestForm.FormStorage1RestorePlacement(Sender: TObject);
var
	lStr: string;
begin
	lStr := SaveDirBtn.caption;
	if not DirExists(lStr) then
		lStr := extractfiledir(paramstr(0));
	SetSaveDir( lStr);
end;

procedure TTestForm.EmulateCheckClick(Sender: TObject);
begin
    kKBEmulate := EmulateCheck.checked;
    //kMouseEmulate := MouseCheck.checked;
end;

end.
